package de.uks.se.castle.creators;

import org.sdmlib.models.pattern.PatternObject;
import de.uks.se.castle.Castle;
import de.uks.se.castle.creators.CastleSet;
import org.sdmlib.models.pattern.PatternLink;
import de.uks.se.castle.creators.RoomPO;
import org.sdmlib.models.pattern.LinkConstraint;
import de.uks.se.castle.creators.CastlePO;
import de.uks.se.castle.Room;
import de.uks.se.castle.creators.RoomSet;
import de.uks.se.castle.creators.PersonPO;
import de.uks.se.castle.Person;
import de.uks.se.castle.creators.PersonSet;

public class CastlePO extends PatternObject<CastlePO, Castle>
{
   public CastleSet allMatches()
   {
      this.setDoAllMatches(true);
      
      CastleSet matches = new CastleSet();

      while (this.getPattern().getHasMatch())
      {
         matches.add((Castle) this.getCurrentMatch());
         
         this.getPattern().findMatch();
      }
      
      return matches;
   }
   
   
   //==========================================================================
   
   public int countAllItems()
   {
      if (this.getPattern().getHasMatch())
      {
         return ((Castle) getCurrentMatch()).countAllItems();
      }
      return 0;
   }

   
   //==========================================================================
   
   public void princessSaved()
   {
      if (this.getPattern().getHasMatch())
      {
          ((Castle) getCurrentMatch()).princessSaved();
      }
   }

   public RoomPO hasRooms()
   {
      RoomPO result = new RoomPO();
      result.setModifier(this.getPattern().getModifier());
      
      super.hasLink(Castle.PROPERTY_ROOMS, result);
      
      return result;
   }

   public CastlePO hasRooms(RoomPO tgt)
   {
      LinkConstraint patternLink = (LinkConstraint) new LinkConstraint()
      .withTgt(tgt).withTgtRoleName(Castle.PROPERTY_ROOMS)
      .withSrc(this)
      .withModifier(this.getPattern().getModifier());
      
      this.getPattern().addToElements(patternLink);
      
      this.getPattern().findMatch();
      
      return this;
   }

   public RoomSet getRooms()
   {
      if (this.getPattern().getHasMatch())
      {
         return ((Castle) this.getCurrentMatch()).getRooms();
      }
      return null;
   }

   public PersonPO hasPersons()
   {
      PersonPO result = new PersonPO();
      result.setModifier(this.getPattern().getModifier());
      
      super.hasLink(Castle.PROPERTY_PERSONS, result);
      
      return result;
   }

   public CastlePO hasPersons(PersonPO tgt)
   {
      LinkConstraint patternLink = (LinkConstraint) new LinkConstraint()
      .withTgt(tgt).withTgtRoleName(Castle.PROPERTY_PERSONS)
      .withSrc(this)
      .withModifier(this.getPattern().getModifier());
      
      this.getPattern().addToElements(patternLink);
      
      this.getPattern().findMatch();
      
      return this;
   }

   public PersonSet getPersons()
   {
      if (this.getPattern().getHasMatch())
      {
         return ((Castle) this.getCurrentMatch()).getPersons();
      }
      return null;
   }

}

