package de.uks.se.castle.creators;

import java.util.LinkedHashSet;
import org.sdmlib.serialization.interfaces.SendableEntityCreator;
import org.sdmlib.serialization.json.JsonIdMap;
import org.sdmlib.serialization.json.SDMLibJsonIdMap;

public class CreatorCreator
{
   public static LinkedHashSet<SendableEntityCreator> creatorSet = null;
   
   public static LinkedHashSet<SendableEntityCreator> getCreatorSet()
   {
      if (creatorSet == null)
      {
         creatorSet = new LinkedHashSet<SendableEntityCreator>();
         creatorSet.add(new de.uks.se.castle.creators.CastleCreator());
         creatorSet.add(new de.uks.se.castle.creators.CastlePOCreator());
         creatorSet.add(new de.uks.se.castle.creators.RoomCreator());
         creatorSet.add(new de.uks.se.castle.creators.RoomPOCreator());
         creatorSet.add(new de.uks.se.castle.creators.PersonCreator());
         creatorSet.add(new de.uks.se.castle.creators.PersonPOCreator());
         creatorSet.add(new de.uks.se.castle.creators.ItemCreator());
         creatorSet.add(new de.uks.se.castle.creators.ItemPOCreator());
         creatorSet.add(new de.uks.se.castle.creators.PrincessCreator());
         creatorSet.add(new de.uks.se.castle.creators.PrincessPOCreator());
         creatorSet.addAll(org.sdmlib.models.pattern.creators.CreatorCreator.getCreatorSet());
      }
      
      return creatorSet;
   }

   public static JsonIdMap createIdMap(String sessionID)
   {
      JsonIdMap jsonIdMap = new SDMLibJsonIdMap().withSessionId(sessionID);
      
      jsonIdMap.addCreator(getCreatorSet());

      return jsonIdMap;
   }
}

