/*
   Copyright (c) 2013 deeptought 
   
   Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
   and associated documentation files (the "Software"), to deal in the Software without restriction, 
   including without limitation the rights to use, copy, modify, merge, publish, distribute, 
   sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
   furnished to do so, subject to the following conditions: 
   
   The above copyright notice and this permission notice shall be included in all copies or 
   substantial portions of the Software. 
   
   The Software shall be used for Good, not Evil. 
   
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
   BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
 */
   
package de.uks.se.castle.creators;

import java.util.LinkedHashSet;
import de.uks.se.castle.Item;
import org.sdmlib.models.modelsets.StringList;
import java.util.List;
import org.sdmlib.models.modelsets.intList;
import de.uks.se.castle.creators.RoomSet;
import de.uks.se.castle.Room;
import de.uks.se.castle.creators.PersonSet;
import de.uks.se.castle.Person;

public class ItemSet extends LinkedHashSet<Item> implements org.sdmlib.models.modelsets.ModelSet
{


   public String toString()
   {
      StringList stringList = new StringList();
      
      for (Item elem : this)
      {
         stringList.add(elem.toString());
      }
      
      return "(" + stringList.concat(", ") + ")";
   }


   public String getEntryType()
   {
      return "de.uks.se.castle.Item";
   }


   public ItemSet with(Item value)
   {
      this.add(value);
      return this;
   }
   
   public ItemSet without(Item value)
   {
      this.remove(value);
      return this;
   }
   public StringList getDescription()
   {
      StringList result = new StringList();
      
      for (Item obj : this)
      {
         result.add(obj.getDescription());
      }
      
      return result;
   }

   public ItemSet withDescription(String value)
   {
      for (Item obj : this)
      {
         obj.setDescription(value);
      }
      
      return this;
   }

   public intList getQuality()
   {
      intList result = new intList();
      
      for (Item obj : this)
      {
         result.add(obj.getQuality());
      }
      
      return result;
   }

   public ItemSet withQuality(int value)
   {
      for (Item obj : this)
      {
         obj.setQuality(value);
      }
      
      return this;
   }

   public RoomSet getRoom()
   {
      RoomSet result = new RoomSet();
      
      for (Item obj : this)
      {
         result.add(obj.getRoom());
      }
      
      return result;
   }

   public ItemSet withRoom(Room value)
   {
      for (Item obj : this)
      {
         obj.withRoom(value);
      }
      
      return this;
   }

   public PersonSet getPerson()
   {
      PersonSet result = new PersonSet();
      
      for (Item obj : this)
      {
         result.add(obj.getPerson());
      }
      
      return result;
   }

   public ItemSet withPerson(Person value)
   {
      for (Item obj : this)
      {
         obj.withPerson(value);
      }
      
      return this;
   }

}

