package de.uks.se.castle.creators;

import org.sdmlib.models.pattern.Pattern;
import de.uks.se.castle.creators.CastlePO;
import de.uks.se.castle.Castle;
import de.uks.se.castle.creators.RoomPO;
import de.uks.se.castle.Room;
import de.uks.se.castle.creators.PersonPO;
import de.uks.se.castle.Person;
import de.uks.se.castle.creators.ItemPO;
import de.uks.se.castle.Item;
import de.uks.se.castle.creators.PrincessPO;
import de.uks.se.castle.Princess;

public class ModelPattern extends Pattern
{
   public ModelPattern()
   {
      super(CreatorCreator.createIdMap("hg"));
   }
   
   public ModelPattern startCreate()
   {
      super.startCreate();
      return this;
   }

   public CastlePO hasElementCastlePO()
   {
      CastlePO value = new CastlePO();
      this.addToElements(value);
      value.setModifier(this.getModifier());
      
      this.findMatch();
      
      return value;
   }
   
   public CastlePO hasElementCastlePO(Castle hostGraphObject)
   {
      CastlePO value = new CastlePO();
      this.addToElements(value);
      value.setModifier(Pattern.BOUND);
      
      value.setCurrentMatch(hostGraphObject);
      
      this.findMatch();
      
      return value;
   } 

   public RoomPO hasElementRoomPO()
   {
      RoomPO value = new RoomPO();
      this.addToElements(value);
      value.setModifier(this.getModifier());
      
      this.findMatch();
      
      return value;
   }
   
   public RoomPO hasElementRoomPO(Room hostGraphObject)
   {
      RoomPO value = new RoomPO();
      this.addToElements(value);
      value.setModifier(Pattern.BOUND);
      
      value.setCurrentMatch(hostGraphObject);
      
      this.findMatch();
      
      return value;
   } 

   public PersonPO hasElementPersonPO()
   {
      PersonPO value = new PersonPO();
      this.addToElements(value);
      value.setModifier(this.getModifier());
      
      this.findMatch();
      
      return value;
   }
   
   public PersonPO hasElementPersonPO(Person hostGraphObject)
   {
      PersonPO value = new PersonPO();
      this.addToElements(value);
      value.setModifier(Pattern.BOUND);
      
      value.setCurrentMatch(hostGraphObject);
      
      this.findMatch();
      
      return value;
   } 

   public ItemPO hasElementItemPO()
   {
      ItemPO value = new ItemPO();
      this.addToElements(value);
      value.setModifier(this.getModifier());
      
      this.findMatch();
      
      return value;
   }
   
   public ItemPO hasElementItemPO(Item hostGraphObject)
   {
      ItemPO value = new ItemPO();
      this.addToElements(value);
      value.setModifier(Pattern.BOUND);
      
      value.setCurrentMatch(hostGraphObject);
      
      this.findMatch();
      
      return value;
   } 

   public PrincessPO hasElementPrincessPO()
   {
      PrincessPO value = new PrincessPO();
      this.addToElements(value);
      value.setModifier(this.getModifier());
      
      this.findMatch();
      
      return value;
   }
   
   public PrincessPO hasElementPrincessPO(Princess hostGraphObject)
   {
      PrincessPO value = new PrincessPO();
      this.addToElements(value);
      value.setModifier(Pattern.BOUND);
      
      value.setCurrentMatch(hostGraphObject);
      
      this.findMatch();
      
      return value;
   } 

}


