package de.uks.se.castle.creators;

import org.sdmlib.models.pattern.PatternObject;
import de.uks.se.castle.Princess;
import de.uks.se.castle.creators.PrincessSet;
import org.sdmlib.models.pattern.AttributeConstraint;
import org.sdmlib.models.pattern.PatternLink;
import de.uks.se.castle.creators.RoomPO;
import org.sdmlib.models.pattern.LinkConstraint;
import de.uks.se.castle.creators.PrincessPO;
import de.uks.se.castle.Room;
import de.uks.se.castle.creators.PersonPO;
import de.uks.se.castle.Person;

public class PrincessPO extends PatternObject<PrincessPO, Princess>
{
   public PrincessSet allMatches()
   {
      this.setDoAllMatches(true);
      
      PrincessSet matches = new PrincessSet();

      while (this.getPattern().getHasMatch())
      {
         matches.add((Princess) this.getCurrentMatch());
         
         this.getPattern().findMatch();
      }
      
      return matches;
   }
   
   public PrincessPO hasName(String value)
   {
      AttributeConstraint constr = (AttributeConstraint) new AttributeConstraint()
      .withAttrName(Princess.PROPERTY_NAME)
      .withTgtValue(value)
      .withSrc(this)
      .withModifier(this.getPattern().getModifier())
      .withPattern(this.getPattern());
      
      this.getPattern().findMatch();
      
      return this;
   }
   
   public String getName()
   {
      if (this.getPattern().getHasMatch())
      {
         return ((Princess) getCurrentMatch()).getName();
      }
      return null;
   }
   
   public PrincessPO withName(String value)
   {
      if (this.getPattern().getHasMatch())
      {
         ((Princess) getCurrentMatch()).setName(value);
      }
      return this;
   }
   
   public RoomPO hasRoom()
   {
      RoomPO result = new RoomPO();
      result.setModifier(this.getPattern().getModifier());
      
      super.hasLink(Princess.PROPERTY_ROOM, result);
      
      return result;
   }

   public PrincessPO hasRoom(RoomPO tgt)
   {
      LinkConstraint patternLink = (LinkConstraint) new LinkConstraint()
      .withTgt(tgt).withTgtRoleName(Princess.PROPERTY_ROOM)
      .withSrc(this)
      .withModifier(this.getPattern().getModifier());
      
      this.getPattern().addToElements(patternLink);
      
      this.getPattern().findMatch();
      
      return this;
   }

   public Room getRoom()
   {
      if (this.getPattern().getHasMatch())
      {
         return ((Princess) this.getCurrentMatch()).getRoom();
      }
      return null;
   }

   public PersonPO hasPrince()
   {
      PersonPO result = new PersonPO();
      result.setModifier(this.getPattern().getModifier());
      
      super.hasLink(Princess.PROPERTY_PRINCE, result);
      
      return result;
   }

   public PrincessPO hasPrince(PersonPO tgt)
   {
      LinkConstraint patternLink = (LinkConstraint) new LinkConstraint()
      .withTgt(tgt).withTgtRoleName(Princess.PROPERTY_PRINCE)
      .withSrc(this)
      .withModifier(this.getPattern().getModifier());
      
      this.getPattern().addToElements(patternLink);
      
      this.getPattern().findMatch();
      
      return this;
   }

   public Person getPrince()
   {
      if (this.getPattern().getHasMatch())
      {
         return ((Princess) this.getCurrentMatch()).getPrince();
      }
      return null;
   }

}

