/*
   Copyright (c) 2013 deeptought 
   
   Permission is hereby granted, free of charge, to any person obtaining a copy of this software 
   and associated documentation files (the "Software"), to deal in the Software without restriction, 
   including without limitation the rights to use, copy, modify, merge, publish, distribute, 
   sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is 
   furnished to do so, subject to the following conditions: 
   
   The above copyright notice and this permission notice shall be included in all copies or 
   substantial portions of the Software. 
   
   The Software shall be used for Good, not Evil. 
   
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING 
   BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND 
   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
 */
   
package de.uks.se.castle.creators;

import java.util.LinkedHashSet;
import de.uks.se.castle.Room;
import org.sdmlib.models.modelsets.StringList;
import org.sdmlib.models.modelsets.intList;
import java.util.List;
import de.uks.se.castle.creators.CastleSet;
import de.uks.se.castle.Castle;
import de.uks.se.castle.creators.PersonSet;
import de.uks.se.castle.Person;
import de.uks.se.castle.creators.ItemSet;
import de.uks.se.castle.Item;
import de.uks.se.castle.creators.PrincessSet;
import de.uks.se.castle.Princess;

public class RoomSet extends LinkedHashSet<Room> implements org.sdmlib.models.modelsets.ModelSet
{


   public String toString()
   {
      StringList stringList = new StringList();
      
      for (Room elem : this)
      {
         stringList.add(elem.toString());
      }
      
      return "(" + stringList.concat(", ") + ")";
   }


   public String getEntryType()
   {
      return "de.uks.se.castle.Room";
   }


   public RoomSet with(Room value)
   {
      this.add(value);
      return this;
   }
   
   public RoomSet without(Room value)
   {
      this.remove(value);
      return this;
   }
   public intList getNr()
   {
      intList result = new intList();
      
      for (Room obj : this)
      {
         result.add(obj.getNr());
      }
      
      return result;
   }

   public RoomSet withNr(int value)
   {
      for (Room obj : this)
      {
         obj.setNr(value);
      }
      
      return this;
   }

   public CastleSet getCastle()
   {
      CastleSet result = new CastleSet();
      
      for (Room obj : this)
      {
         result.add(obj.getCastle());
      }
      
      return result;
   }

   public RoomSet withCastle(Castle value)
   {
      for (Room obj : this)
      {
         obj.withCastle(value);
      }
      
      return this;
   }

   public PersonSet getPersons()
   {
      PersonSet result = new PersonSet();
      
      for (Room obj : this)
      {
         result.addAll(obj.getPersons());
      }
      
      return result;
   }

   public RoomSet withPersons(Person value)
   {
      for (Room obj : this)
      {
         obj.withPersons(value);
      }
      
      return this;
   }

   public RoomSet withoutPersons(Person value)
   {
      for (Room obj : this)
      {
         obj.withoutPersons(value);
      }
      
      return this;
   }

   public ItemSet getItems()
   {
      ItemSet result = new ItemSet();
      
      for (Room obj : this)
      {
         result.addAll(obj.getItems());
      }
      
      return result;
   }

   public RoomSet withItems(Item value)
   {
      for (Room obj : this)
      {
         obj.withItems(value);
      }
      
      return this;
   }

   public RoomSet withoutItems(Item value)
   {
      for (Room obj : this)
      {
         obj.withoutItems(value);
      }
      
      return this;
   }

   public PrincessSet getPrincess()
   {
      PrincessSet result = new PrincessSet();
      
      for (Room obj : this)
      {
         result.add(obj.getPrincess());
      }
      
      return result;
   }

   public RoomSet withPrincess(Princess value)
   {
      for (Room obj : this)
      {
         obj.withPrincess(value);
      }
      
      return this;
   }

}

