package de.uks.se.pmws1213.sdmlib;

import org.sdmlib.models.classes.ClassModel;
import org.sdmlib.models.classes.Clazz;
import org.sdmlib.models.classes.Role.R;

public class CastleClassModel
{
	private static final String INT = "int";
	private static final String STRING = "String";
	
	public static void main(String[] args)
	{
		ClassModel model = new ClassModel("de.uks.se.castle");
		
		Clazz castleClazz = new Clazz("Castle");
		
		Clazz roomClazz = new Clazz("Room",
									"nr", INT);
		
		Clazz personClazz = new Clazz("Person",
									  "name", STRING,
									  "experience", INT);
		
		Clazz itemClazz = new Clazz("Item",
									"description", STRING,
									"quality", INT);
		
		Clazz princessClazz = new Clazz("Princess",
										"name", STRING);
		
		castleClazz.withAssoc(roomClazz, "rooms", R.MANY, "castle", R.ONE);
		castleClazz.withAssoc(personClazz, "persons", R.MANY, "castle", R.ONE);
		roomClazz.withAssoc(personClazz, "persons", R.MANY, "room", R.ONE);
		roomClazz.withAssoc(itemClazz, "items", R.MANY, "room", R.ONE);
		roomClazz.withAssoc(princessClazz, "princess", R.ONE, "room", R.ONE);
		personClazz.withAssoc(itemClazz, "items", R.MANY, "person", R.ONE);
		personClazz.withAssoc(princessClazz, "savedPrincess", R.ONE, "prince", R.ONE);
		
		castleClazz.withMethods("countAllItems()", INT);
		castleClazz.withMethods("princessSaved()", "void");
		personClazz.withMethods("collectItemsInCurrentRoom()", "void");
		
		model.generate("genSrc","genSrc");
	}
}
